<?php

/*
 *Copyright (C) www.vtiger.com. All rights reserved.
 * @license Proprietary
*/

class Portal_Authenticate2FA_API extends Portal_Default_API {

    public function requireLogin() {
        return false;
    }

    public function process(Portal_Request $request) {
        $authCode = $request->get('auth_code');
        $attempts = Portal_Session::get('2FA_attempts');
        $sessionAuthCode = Portal_Session::get('2FA_CODE');
        $userName = Portal_Session::get('username');
        $password = Portal_Session::get('password');
        Vtiger_Connector::getInstance()->fetchModules($userName, $password);
        if (($attempts > 0) && (trim($authCode) == trim($sessionAuthCode))) {
            Portal_Session::set('WAITING_FOR_AUTH_CODE', false);
            $result['success'] = true;
            $result['url'] .= '&login=true';
        } else {
            $remainingAttempts = ($attempts - 1);
            if ($remainingAttempts <= 0) {
                $result['logout'] = true;
            }
            Portal_Session::set('2FA_attempts', $remainingAttempts);
            $result['remainingAttempts'] = $remainingAttempts;
            $result['error'] = true;
        }
        $response = new Portal_Response();
        $response->setResult($result);
        return $response;
    }
}
